var y y_f C  C_f I q  lambda_c K  mc r  r_k rf bf b_h z_y z_I t tf pi pih pif pif_f ph pf pf_f  w tau_c tau_h 
N  G Gf ;
varexo  xi_y  xi_I xi_q  xi_C_f   xi_rf xi_b xi_pf_f  xi_tau_c xi_tau_h   xi_g  xi_gf;
//----------------------------------------------------//
// Declaration of parameters //
//----------------------------------------------------//
parameters alpha alpha_K beta delta  vepsilon  eta  h   g_y gyf  omega_pi omega_y omega_r phi
sigma vphi   rho_rf  lambda tetha mu_tau_c mu_tau_h c_y    i_y mu_gf t_y tyf
rho_y  rho_I rho_C_f  rho_pf_f rho_g rho_gf  phSS pfSS pf_fSS  r_k_ss  mu_g phi_g phi_b
 pi_fSS rSS  tau_c_ss rho_tau_c rho_bf tau_h_ss  rho_tau_h zeta;
alpha = 0.26;
alpha_K=0.33;
beta = 0.99;
delta=0.025;
tetha=0.5;
vepsilon=5.855;
sigma=1.0;
lambda=(1-tetha)*(1-beta*tetha)/(tetha);
vphi =1.577;
eta = 1.2;
tau_c_ss=0.2;
tau_h_ss=0.13;
r_k_ss=((1/beta)-(1-delta)-delta*tau_h_ss)/(1-tau_h_ss);
mu_tau_c=0.0;
mu_tau_h=0.0;
omega_pi = 1.5;
omega_y = 0.8;
omega_r = 0.8;
phi = 0.002;
h = 0.75;
zeta=3.12;
rho_y = 0.65;
rho_I = 0.65;
rho_g = 0.55;
rho_gf = 0.65;
rho_rf = 0.65;
rho_pf_f = 0.65;
rho_C_f = 0.65;
rho_tau_c = 0.65;
rho_tau_h = 0.65;
rho_bf=0.65;
mu_g=0.0;
mu_gf=0.0;
g_y=0.15;
i_y=0.2;
gyf=0.4;
c_y=0.6;
t_y=0.4;
tyf=0.4;
phSS = 1;
pfSS = 1.0;
pf_fSS=1.0;
pi_fSS = 1;
phi_g=0.13;
phi_b=0.2;
rSS = (1/beta);

//----------------------------------------------------//
// DSGE model specification //
//----------------------------------------------------//
model(linear);
#mcSS=(vepsilon-1)/vepsilon;
#wSS=(mcSS/((r_k_ss^alpha_K)*(1/(1-alpha_K))^(1-alpha_K)*(1/alpha_K)^alpha_K))^(1/(1-alpha_K));
#NSS=(((((1-g_y)*(beta^(-1)-1)-g_y*delta)*(1-h))^(-1))*((1/beta)-1+delta)*(1-alpha)/alpha)^(1/(1+vphi));
#KSS=((((1-g_y)*(beta^(-1)-1)-g_y*delta)*(1-h))^(-1/(1+vphi)))*(alpha_K*mcSS)^((1+vphi)/((1-alpha_K)*(1+vphi)))*((1/beta)-1+delta)^((alpha_K+vphi)/((alpha_K-1)*(1+vphi)))*((1-alpha_K)/alpha_K)^(1/(1+vphi));
#ySS=(KSS^alpha_K)*NSS^(1-alpha_K);
#CSS=((1-g_y)*mcSS*(KSS/NSS)^alpha_K-delta*(KSS/NSS))*NSS;
#ISS=delta*KSS;
#ch_f_y = 0.025*CSS;
#GSS=g_y*ySS;
#GfSS=gyf*ySS;
#tSS=tau_h_ss*wSS*NSS+tau_h_ss*r_k_ss*KSS;
#tfSS=tau_c_ss*CSS;
//Demand
y=c_y*(1-alpha)*(phSS^(-eta))*(C-eta*ph)+g_y*G+i_y*I+ ch_f_y*(C_f-eta*(ph-pf_f));
y = z_y+alpha_K*K(-1)+(1-alpha_K)*N;
//Euler
r = (sigma/(1-h))*C(+1)-((1+h)/(1-h))*sigma*C+(h*sigma/(1-h))*C(-1)+pi(+1)-(tau_c_ss/(1+tau_c_ss))*(tau_c-tau_c(+1));
I=((1+beta)^(-1))*I(-1)+(beta/(1+beta))*I(+1)+(zeta/(1+beta))*q-(beta*z_I(+1)-z_I)/(1+beta);
q=-(r-pi(+1))+((1-delta)/((1-delta)+(1-tau_h_ss)*r_k_ss))*q(+1)+((1-tau_h_ss)*r_k_ss/((1-delta)+(1-tau_h_ss)*r_k_ss))*r_k(+1)-(tau_h_ss*r_k_ss/((1-delta)+(1-tau_h_ss)*r_k_ss))*tau_h(+1)+xi_q;
K=(1-delta)*K(-1)+delta*I;
lambda_c=-((tau_c_ss*tau_c)/(1+tau_c_ss))-(C-h*C(-1))/(1-h);
//Intratemporal
w = vphi*N+(sigma/(1-h))*C-((sigma*h)/(1-h))*C(-1)+(tau_c_ss/(1+tau_c_ss))*tau_c+(tau_h_ss/(1-tau_h_ss))*tau_h;
N=-w+K(-1)+r_k;
//Producer FOC
mc=alpha_K*r_k+(1-alpha_K)*(w)-z_y;
pih=beta*pih(+1)+lambda*mc;
pif=beta*pif(+1)+lambda*(pf_f-pf);
//UIP
r -rf= -phi*bf*ySS+xi_b;
//Taylor
//rf = omega_r*rf(-1)+((1-omega_r)/rSS)*(omega_pi*pif_f+omega_y*ySS*(y_f-y_f(-1)))+xi_rf;
//rf=omega_pi*pif_f+omega_y*(y_f-y_f(-1))+xi_rf;
rf=omega_pi*pi+xi_rf;
pif = pf-pf(-1)+pi;
pih = ph-ph(-1)+pi;
pif_f=pf_f-pf_f(-1)+pi;
beta*b_h=b_h(-1)+g_y*G-t_y*t;
beta*bf=bf(-1)+gyf*Gf-tyf*tf;
//AR1-processes
G = rho_g*G(-1)+(1-rho_g)*mu_g*(b_h(-1)-y(-1))+xi_g;
Gf = rho_gf*Gf(-1)+(1-rho_gf)*mu_gf*(bf(-1)-y_f(-1))+xi_gf;
t*tSS=tau_h_ss*wSS*NSS*(tau_h+w+N)+tau_h_ss*r_k_ss*KSS*(tau_h+r_k+K);
tf*tfSS=tau_c_ss*CSS*(tau_c+C);
t=phi_b*b_h*ySS+phi_g*G;
y_f = rho_y*y_f(-1)+xi_y;
pf_f = rho_pf_f*pf_f(-1)+xi_pf_f;
C_f = rho_C_f*C_f(-1)+xi_C_f;
z_y = rho_y*z_y(-1)+xi_y;
z_I = rho_I*z_I(-1)+xi_I;
tau_c= rho_tau_c*tau_c(-1)+(1-rho_tau_c)*mu_tau_c*(b_h(-1)-y(-1))+xi_tau_c;
tau_h= rho_tau_h*tau_h(-1)++(1-rho_tau_h)*mu_tau_h*(b_h(-1)-y(-1))+xi_tau_h;
end;
// Declaring observables
varobs  C w y  pif r rf y_f;

// Compute steady state
steady; //
// Compute eigenvalues and check Blanchard-Kahn conditions
check;
//resid(1);
options_debug=1;
estimated_params;
phi,inv_gamma_pdf,0.002,0.5;
phi_g,inv_gamma_pdf,0.1,0.5;
phi_b,inv_gamma_pdf,0.1,0.5;
vphi,inv_gamma_pdf,1.777,0.5;
eta,inv_gamma_pdf,0.8,0.5;
zeta,inv_gamma_pdf,1.5,0.5;
//mu, beta_pdf, 0.65, 0.1;
//mu_g,inv_gamma_pdf,0.05,0.2;
//mu_gf,inv_gamma_pdf,0.05,0.2;
//mu_tau_c,inv_gamma_pdf,0.05,0.2;
//mu_tau_h,inv_gamma_pdf,0.05,0.2;
omega_pi,inv_gamma_pdf,1.2,0.2;
//omega_y,inv_gamma_pdf,0.8,0.2;
//omega_r,inv_gamma_pdf,0.8,0.1;
rho_y, beta_pdf, 0.5, 0.1;
rho_I, beta_pdf, 0.5, 0.1;
rho_g, beta_pdf, 0.7, 0.1;
rho_gf, beta_pdf, 0.8, 0.1;
rho_rf, beta_pdf, 0.8, 0.1;
rho_bf, beta_pdf, 0.8, 0.1;
rho_C_f, beta_pdf, 0.8, 0.1;
rho_tau_c,beta_pdf, 0.8, 0.1;
rho_tau_h,beta_pdf, 0.8, 0.1;
stderr xi_y,INV_GAMMA_PDF,0.02,inf;
stderr xi_I,INV_GAMMA_PDF,0.02,inf;
stderr xi_q,INV_GAMMA_PDF,0.02,inf;
stderr xi_b,INV_GAMMA_PDF,0.02,inf;
stderr xi_g,INV_GAMMA_PDF,0.012,inf;
stderr xi_gf,INV_GAMMA_PDF,0.012,inf;
stderr xi_rf,INV_GAMMA_PDF,.0025,inf;
stderr xi_pf_f,INV_GAMMA_PDF,.0025,inf;
stderr xi_tau_c,INV_GAMMA_PDF,0.005,inf;
stderr xi_tau_h,INV_GAMMA_PDF,0.05,inf;
stderr xi_C_f,INV_GAMMA_PDF,0.02,inf;
end;

estimation(datafile=data_estim,mode_compute=4,kalman_algo=1,lik_init=2,first_obs=1,prefilter=1,mh_replic=500,mh_nblocks=1,
mh_jscale=0.5,mode_check);
model_diagnostics;
//identification
stoch_simul(order=1,irf=40) C I w  y rf pi;